package gomod

import (
	"fmt"
	"net/http"
	
	"path/filepath"
	"encoding/json"
	"onlinePaySplitGoSDK/models"
	"onlinePaySplitGoSDK/utils"
)

//订单退款请求
func RefundRequest(w http.ResponseWriter, r *http.Request) {
	 //接口地址
	 apiurl := "https://apis.5upay.com/onlinePay/refund"
	 //pfx私钥
	 privatepfxpath, pfxerr := filepath.Abs("package/client.pfx")
	 if pfxerr != nil {  
	    fmt.Println("pfxerr:", pfxerr)  
	 } 
	 pfxpwd := "123456"
     //cer公钥
	 publiccerpath, cererr := filepath.Abs("package/payease.cer")
	 if cererr != nil {  
	    fmt.Println("cererr:", cererr)  
	 } 

	 //生成16位随机数
     var aesKeyValue string  = utils.GetRandomString(16)

	 //获取前端参数
	 r.ParseForm()
	 var refundorder models.RefundOrder
	 refundorder.MerchantId = utils.IsNull(r.Form["merchantId"])
	 refundorder.RequestId = utils.IsNull(r.Form["requestId"])
	 refundorder.PartnerId = utils.IsNull(r.Form["partnerId"])
	 refundorder.Amount = utils.IsNull(r.Form["amount"])
     refundorder.OrderId = utils.IsNull(r.Form["orderId"])
     refundorder.NotifyUrl = utils.IsNull(r.Form["notifyUrl"])
     refundorder.Remark = utils.IsNull(r.Form["remark"])

	 
	  //把订单对象数据转JSON字符串
	 orderdata, err := json.Marshal(refundorder)  
	if err != nil {  
	     fmt.Println("err:", err) 
	    return  
	}  

	//排序
	sortdata, oerr := utils.GetMapSortJson(string(orderdata))
	if oerr != nil {
        fmt.Println("oerr:", oerr)
    } 
	fmt.Println("排序：",sortdata)

	//hamc
	hm := utils.Sha1(sortdata)
	hmac,err := utils.Sign(hm,privatepfxpath,pfxpwd)
	if err != nil {
        fmt.Println("err:", err)
    } 
	refundorder.Hmac = hmac


	orderjson, err := json.Marshal(refundorder)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}

	//将byte转换成string进行打印
	fmt.Println("提交订单信息：",string(orderjson))

	//加密的encryptKey秘钥
	encryptKey,enerr := utils.PublicEncrypt(aesKeyValue, publiccerpath)
	if enerr != nil {
        fmt.Println("err:", enerr)
    } 
	fmt.Println("encryptKey：",encryptKey)

	//返回体 data
	aesdata,aeserro := utils.AesECBEncrypt(string(orderjson), aesKeyValue)
	if aeserro != nil {
        fmt.Println("err:", aeserro)
    } 
	fmt.Println("aesdata：",aesdata)

	//提交请求
	response, rperr := utils.Post(apiurl,encryptKey,refundorder.MerchantId,refundorder.RequestId,refundorder.PartnerId,aesdata,privatepfxpath,pfxpwd)
	if rperr != nil {
        fmt.Println("rperr:", rperr)
    } 

	//返回
	var refunorderback models.OrderResponse
    json.Unmarshal([]byte(response), &refunorderback)
    rhmac := refunorderback.Hmac
    if 	rhmac != ""{
    	sortdeldata, oerr := utils.GetDelJson(string(response),"hmac")
		if oerr != nil {
	        fmt.Println("oerr:", oerr)
	    } 
		signhm := utils.Sha1(sortdeldata)
    	verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
    	if verr == nil {
    		status := refunorderback.Status
    		if status == "SUCCESS"{
    			fmt.Println("提交成功:", response)
    			fmt.Fprintf(w, "退款提交成功\n"+ response)
    		}else{
    			fmt.Println("提交异常:", response)
    			fmt.Fprintf(w, "退款提交异常\n"+ response)
    		}
    	}else{
	    	fmt.Println("verr:", verr)
    	}
    }else{
    	fmt.Println("返回数据:", response)
    	fmt.Fprintf(w, "错误信息\n"+ response)
    }
}














