package models

// 统一收单
type PayOrder struct {
	MerchantId string `json:"merchantId"`
    OrderAmount string `json:"orderAmount"`
    OrderCurrency string `json:"orderCurrency"`
    RequestId string `json:"requestId"`
    PartnerId string `json:"partnerId"`
    NotifyUrl string `json:"notifyUrl"`
    CallbackUrl string `json:"callbackUrl"`
    Remark string `json:"remark"`
    PaymentModeCode string `json:"paymentModeCode"`
    AuthCode string `json:"authCode"`
    OpenId string `json:"openId"`
    AppId string `json:"appId"`
    ProductDetails []ProductDetail `json:"productDetails"`
    SplitMark string `json:"splitMark"`
    Payer Payer `json:"payer"`
    ClientIp string `json:"clientIp"`
    Timeout string `json:"timeout"`
    MerchantUserId string `json:"merchantUserId"`
    BindCardId string `json:"bindCardId"`
    ReportSerialNo string `json:"reportSerialNo"`
    LimitAccType string `json:"limitAccType"`
    SubsidyMark string `json:"subsidyMark"`
    SubsidyAmount string `json:"subsidyAmount"`
    NeedOpenLink string `json:"needOpenLink"`
    Hmac string `json:"hmac"`
}

//身份信息
type Payer struct {
    Name  string `json:"name"`  
    PhoneNum string `json:"phoneNum"`
    IdType     string `json:"idType"`
    IdNum  string `json:"idNum"`
    BankCardNum string `json:"bankCardNum"`
    Email string `json:"email"`
   
}

//商品信息
type ProductDetail struct {
    Name  string  `json:"name"`
    Quantity  string `json:"quantity"`
    Amount  string `json:"amount"`
    Receiver string `json:"receiver"`
    Description string `json:"description"`
}


//订单请求后响应数据
type PayOrderBacks struct{
	MerchantId string `json:"merchantId"`    
    RequestId string `json:"requestId"`
    PartnerId string `json:"partnerId"`
    RedirectUrl string `json:"redirectUrl"`
    ScanCode string `json:"scanCode"`
    AppParams string `json:"appParams"`
    JsString string `json:"jsString"`
    PaymentOrderId string `json:"paymentOrderId"`
    ResponseObject
}



// 提交查询订单信息
type QueryOrder struct {
	MerchantId string `json:"merchantId"`
    RequestId string `json:"requestId"`
    PartnerId string `json:"partnerId"`
    Hmac string `json:"hmac"`
}


// 提交退款订单信息
type RefundOrder struct {
	MerchantId string `json:"merchantId"`
    RequestId string `json:"requestId"`
    PartnerId string `json:"partnerId"`
    Amount string `json:"amount"`
    OrderId string `json:"orderId"`
    NotifyUrl string `json:"notifyUrl"`
    Remark string `json:"remark"`
    Hmac string `json:"hmac"`
}


// 分账
type SplitOrder struct {
	MerchantId string `json:"merchantId"`
    RequestId string `json:"requestId"`
    PartnerId string `json:"partnerId"`
    OrderId string `json:"orderId"`
    TotalSplitAmount string `json:"totalSplitAmount"`
    SplitDetails []SplitDetail `json:"splitDetails"`
    NotifyUrl string `json:"notifyUrl"`
    Hmac string `json:"hmac"`
}

//分账信息
type SplitDetail struct {
    SubSplitRequestId  string  `json:"subSplitRequestId"`
    SplitAccType  string `json:"splitAccType"`
    SplitAccId  string `json:"splitAccId"`
    SplitAmount string `json:"splitAmount"`
    Remark string `json:"remark"`
}


// 分账查询啊
type SplitQuery struct {
	MerchantId string `json:"merchantId"`
    RequestId string `json:"requestId"`
    PartnerId string `json:"partnerId"`
    SubSplitRequestId string `json:"subSplitRequestId"`
    Hmac string `json:"hmac"`
}


//订单响应内容
type OrderResponse struct{
	MerchantId string `json:"merchantId"`    
    RequestId string `json:"requestId"`
    PartnerId string `json:"partnerId"`
    ResponseObject
}